#include <iostream>
#include "Topic_Struct_DCPS.hpp"
#include "Topic_StructSplDcps.h"

using namespace std;

int main()
{
    std::cout<<"Topic_StructSplDcps"<<std::endl;
    dds::domain::DomainParticipant dp(org::opensplice::domain::default_id());

    //    dds::pub::Publisher pub(dp);
    dds::sub::Subscriber sub(dp);

    dds::core::Duration obj1;    obj1.infinite();
    dds::core::policy::Deadline obj;   obj.period().infinite();
    dds::core::policy::LatencyBudget lobj;   lobj.duration(dds::core::Duration().zero());
    dds::topic::qos::TopicQos topicQos = dp.default_topic_qos()
            << obj
            << lobj
            << dds::core::policy::Ownership::Shared();
    dds::topic::Topic<topicNameSpace::topicName> topic(dp, "DummyTopic",topicQos);
    dds::sub::qos::DataReaderQos drqos = topic.qos();
    //    dds::pub::qos::DataWriterQos dwqos = topic.qos();

    //    dds::pub::DataWriter<topicNameSpace::topicName> dw(pub, topic, dwqos);
    dds::sub::DataReader<topicNameSpace::topicName> dr(sub, topic, drqos);

    int i=0;
    while(true){
//        topicNameSpace::topicName tpN;
//        tpN.msg("Hello_World");
//        dw.write(tpN);

        dds::sub::LoanedSamples<topicNameSpace::topicName> sample1=dr.read();
        for(dds::sub::LoanedSamples<topicNameSpace::topicName>::const_iterator sample =sample1.begin();sample<sample1.end();++sample){
            if(sample->info().valid()){
                std::cout<<"Topic_StructSplDcps MSG"<<sample->data().msg()<<std::endl;
            }
        }
        sleep(2);
        i++;
    }
    return 0;
}
